import { demoConfig2 } from "./demo-config";
import "@vanillawc/wc-codemirror";

import { makeGraph } from "./hat-graph/make-graph";

function nodeSelected(ev) {
  const code = document.querySelector("#snippet");
  code.value = jsyaml.safeDump(ev.detail.config);
  code.currentNode = ev.target;
}

function rebuildGraph(config) {
  const graphCard = document.querySelector("#graph");

  while (graphCard.firstChild) graphCard.removeChild(graphCard.firstChild);

  const graph = makeGraph(config);
  graph.addEventListener("node-selected", nodeSelected);
  graph.addEventListener("update-node", (ev) => {
    const code = document.querySelector("#fullcode");
    code.value = jsyaml.safeDump(ev.detail.config);
    window.setTimeout(() => rebuildGraph(ev.detail.config), 100);
  });

  graphCard.appendChild(graph);
}

function setup_snippet_editor() {
  document.querySelector("#saveSnippet").onclick = () => {
    const code = document.querySelector("#snippet");
    if (code.currentNode) {
      code.currentNode.updateNode(jsyaml.safeLoad(code.value));
    }
  };
  document.querySelector("#deleteSnippet").onclick = () => {
    const code = document.querySelector("#snippet");
    if (code.currentNode) {
      code.currentNode.deleteNode();
    }
  };
}

function setup() {
  setup_snippet_editor();

  let src = demoConfig2;
  const fullcode = document.querySelector("#fullcode");
  fullcode.mode = "yaml";
  window.setTimeout(() => (fullcode.value = jsyaml.safeDump(src)), 100);

  rebuildGraph(src);

  const updateButton = document.querySelector("#updateButton");
  updateButton.addEventListener("click", () => {
    src = jsyaml.safeLoad(fullcode.value);
    rebuildGraph(src);
  });
}

setup();
